#!/usr/local/bin/perl
#
# gsauth.pl
# ------------------------------------------------------------- #
# script which produces *.chat file for starting
# IRC client with authentication string
# ------------------------------------------------------------- #

require "./cgi-lib.pl";
require "./user.pl";

$error = "";

if( !&ReadParse(*input)
    || length($input{'nickname'}) <= 0
    || length($input{'firstname'}) <= 0
    || length($input{'lastname'}) <= 0 )
{
   # some essential data not entered
   print &PrintHeader();
   print &PrintTitle( "Missing information !" );

   print "<H1>To enter Global Stage you need to provide</H1>";
   print "<UL>";
   print "<LI><STRONG>nick name</STRONG>";
   print "<LI><STRONG>first name</STRONG>";
   print "<LI><STRONG>last name</STRONG>";
   print "</UL>";
   print "<H2>To<A HREF=\"http://prospero.com/password/index.html\"> START OVER</A>";
   print "<P><H2>Add missing information in";
   print "<A HREF=\"http://prospero.com/password/index.html\"> a Welcome page.</A></H2>";

   print &PrintTail();
   exit;
}


# *** creating time-string
local($time) = time;
$leftZ = '0' x (10-length($time));
$time = $leftZ.$time;

# *** creating ip string
$ip = $ENV{'REMOTE_ADDR'};
if( $ip eq undef )
{
   $error = "CAN_NOT_RETREIVE_CLIENT_IP" ;
   print &PrintHeader();
   print &PrintTitle("Script misconfiguration !");
   print "<P><H3>Try to use \"Back\" button on your browser, ";
   print "reload the page and start \"Global Stage\" again !</H3>";
   print "<P>Error code - $error";
   print &PrintTail();
   exit;
}


# *** retreiving host related information and SECRET. 
open( HOST_INFO, "./gs.secret" ) || ($error = "NO_HOST_INFO_FILE");
while( <HOST_INFO> )
{
   chop;
   /^HOST_NAME=(.*)/ && do{$server = $1;};
   /^PORT=(.*)/ && do{$port = $1;};
   /^SECRET=(.*)/ && do{$secret = $1;};
}
if( $error eq "NO_HOST_INFO_FILE" || $server eq undef
    || $port eq undef || $secret eq undef )
{
   $error = "ERROR_IN_RETREIVING_HOST_INFORMATION";
   print &PrintHeader();
   print &PrintTitle("Script misconfiguration !");
   print "<P><H3>Try to use \"Back\" button on your browser, ";
   print "reload the page and start \"Global Stage\" again !</H3>";
   print "<P>Error code - $error";
   print &PrintTail();
   exit;
}

# *** creating password 'concat $time & magic string'
$inMDstr = $input{'nickname'}.$ip.$time.$secret;
$password = &MD5( $inMDstr );
if( length($password) != 32 )
{
   $error = "ERROR_CREATING_PASSWORD" ;
   print &PrintHeader();
   print &PrintTitle("Script misconfiguration !");
   print "<P><H3>Try to use \"Back\" button on your browser, ";
   print "reload the page and start \"Global Stage\" again !</H3>";
   print "<P>Error code - $error";
   print "<P>Password code - $password";
   print &PrintTail();
   exit;
}
$password = $time.$password;

if($input{'nickname'} eq "bogus")
{
    $password = "Thisisaboguspassword";
}
print <<CHAT_FILE;
# 
Content-type: application/x-chat\n
SERVER $server
PORT $port
NICKNAME $input{'nickname'}
PERSONAL $input{'firstname'} $input{'lastname'}
PASSWORD $password

CHAT_FILE







