#!/usr/local/bin/perl
# Some basic execises
# part of this script should be used for changing 
# users information

require "./cgi-lib.pl";

# &AddUser();

sub AddUser
{
   print &PrintHeader();
   print &PrintTitle( "Adding user information" );

# creating reference file for database manipulation
# here is $id which key to retrieve access information from file
   $id = &StoreUser();
   if( $id > 0 )
   {
# adding user information into database
      if( !&CreateAccount() )
      {
         if( &Connect_DB( 1 ) )
         {
            if( !&UpdateUser() )
            {
               # next step is a launch of a WebPhone
               # or changing user account info
               &OneStep2Launch( $id );
            }
         }
      }
   }
   else
   {
      print '<H1>Unexspected error in creating inter file!</H1>';
   }
      print '</BODY></HTML>';
}

#in intermidiate file
sub StoreUser
{
   # Get unique id to "brand" this session
   local($id) = getppid;

   local($filename) = &MDCrypt( $id );
   if( open( CONFIG, ">/tmp/.$filename.access" ) )
   {
      print CONFIG "username=$input{'nickname'}\n";
      print CONFIG "password=$input{'passwd'}\n";
      close( CONFIG );
   }
   else
   {
# print error msg
      $id = -1;
   }

   return $id;
}

#in intermidiate file
sub RetrieveUser
{
   local($id) = shift(@_);

   local($filename) = &MDCrypt( $id );

   if( open( CONFIG, "/tmp/.$filename.access" ) )
   {

      while (<CONFIG>) 
      {
         $chop;
         s/\s//g;
         ($var, $val) = split(/=/, $_);
         if (/^username/) { $input{'nickname'} = $val; }
         if (/^password/) { $input{'passwd'} = $val; }
      }
      close( CONFIG );
   }
   else
   {
# print error msg
      return -1;
   }

}


# in database
sub CreateAccount
{
# retrieve dba info ?????????????????????????????????????????
   $dba{'username'} = "dba";
   $dba{'password'} = "foo";
# dba login
   local($database) = &ora_login('',"$dba{'username'}","$dba{'password'}") 
          || &Oracle_Error($ora_errstr);
# dba run user create account
# 1. check uniqness of the nick name
   local($query) = "SELECT nickname FROM accounts ";
   $query = $query."WHERE nickname = $input{'nickname'}";

   local($csr) = &ora_open($database, $query );
   local($found) = 0;
   while( &ora_fetch($csr) && $found != 1) 
   {
      $found = 1;
   }
   if (!$found) { print "No rows selected\n"; }

   &ora_close($csr);
   if( !$found )
   {
# 2. create account of the user 'nickname' and 'passwd'
   }
   else
   {
# ask for the different name 
   }

# success return 0
   return 0;
}

# in database
sub Connect_DB
{
# test
$test = shift(@_);
# test
return $test;

   $lda = &ora_login('',"$input{'nickname'}","$input{'passwd'}") 
          || &Oracle_Error($ora_errstr);
   return $lda;

}

# out of database
sub RetrieveData
{
   local( $database ) = shift(@_);
# select of the user's account information
   local($query) = "SELECT nickname, firstname, lastname  ";
   $query = $query.", serialnum, street, city, email, url";
   $query = $query."FROM accounts";
   $query = $query."WHERE nickname = $input{'nickname'}";

   local($csr) = &ora_open($database, $query );
   local($found) = 0;
   while( (@results) =  &ora_fetch($csr) && $found != 1 ) 
   {
      $found = 1;
   }
   if( !$found ) 
   {
# very strange because login has to fail before  
# inform user about it
   }
   else
   {
# it has to be 0 or 1 because nickname is a unique key
      $input{'nickname'} = $results[0];
      $input{'firstname'} = $results[1];
      $input{'lastname'} = $results[2];
      $input{'serialnum'} = $results[3];
      $input{'street'} = $results[4];
      $input{'city'} = $results[5];
      $input{'email'} = $results[6];
      $input{'homepage'} = $results[7];
   }

   &ora_close($csr);
}

#in database
sub UpdateUser
{
# update user account information
   local( $database ) = shift(@_);
# select of the user's account information
   local($query) = "UPDATE nickname, firstname, lastname,";
   $query = $query."serialnum, street, city, email, url";
   $query = $query."FROM accounts";
   $query = $query."SET( $input{'nickname'}, $input{'firstname'},";
   $query = $query."$input{'lastname'}, $input{'serialnum'},";
   $query = $query."$input{'street'}, $input{'city'},";
   $query = $query."$input{'email'}, $input{'homepage'}";
   $query = $query.")";

   local($csr) = &ora_open($database, $query );
  
# analize result

   &ora_close($csr);

# success return 0
   return 0;

}

sub MDCrypt
{
   local($in) = shift(@_);
#this is a place for coding

   return $in;
}

sub MDuCrypt
{
   local($in) = shift(@_);
#this is a place for decoding

   return $in;
}

#############################################################
# ------------------------------------------------------------- #
# Purpose: 	Disconnects from the database			#
# Inputs:	Handle to the Oracle database			#
# ------------------------------------------------------------- #
sub Disconnect_DB
{
  local($database) = shift(@_);

  &ora_logoff($database) || &Oracle_Error($ora_errstr);
}


# ------------------------------------------------------------- #
# Purpose: 	Generates the appropriate error message		#
# Inputs:	Error number, flag for title, severity,		#
#		location					#
# ------------------------------------------------------------- #
sub Error_Msg
{
  local($err_no) = shift(@_);
  local($title) = shift(@_);
  local($todie) = shift(@_);
  local($locat) = shift(@_);

  %errorlist = (
	'OAW-10001', 'Missing ORACLE_SID',
	'OAW-10002', 'Missing TWO_TASK',
	'OAW-10003', 'Missing USERNAME',
	'OAW-10004', 'Missing PASSWORD',
	'OAW-10005', 'Missing Form Name',
	'OAW-10006', 'Missing Form Title',
	'OAW-20001', 'No table selected',
  	'OAW-30001', 'Unable to write session file',
	'OAW-30002', 'Unable to read session file',
	'OAW-30003', 'Unable to write parameters file',
	'OAW-30004', 'Unable to read parameters file',
	'OAW-30005', 'Unable to write form information file',
	'OAW-30006', 'Unable to read form information file',
	'OAW-30007', 'Unable to write form data file',
	'OAW-30008', 'Unable to read form data file',
	'OAW-30009', 'Unable to write form access file',
	'OAW-30010', 'Unable to read form access file',
	'OAW-30011', 'Form file does not exist',
	'OAW-30012', 'Unable to access configs directory',
	'OAW-30013', 'Unable to delete file',
	'OAW-40001', 'No columns selected for form',
	'OAW-40002', 'No where condition specified for required list of values',
	'OAW-40003', 'Invalid SQL statement',
	'OAW-40004', 'List of Values from same table NOT allowed for Insert forms',
	'OAW-40005', 'No information to insert into table',
	'OAW-40006', 'No records were selected for deletion',
	'OAW-40007', 'No record was selected for update',
	'OAW-40008', 'No information entered; update ignored'
  );
  if ($title) {
    print "<HTML><HEAD><TITLE>Error!</TITLE></HEAD>\n";
    print "<BODY><H1>$graphic Error! Error!</H1>\n";
    print "The following error(s) was encountered:\n";
  }
  print "<UL><LI><STRONG>$err_no</STRONG>:  \n";
  print " $errorlist{$err_no} ";
  if (length($locat)) { print ": <EM>$locat</EM>"; }
  print "\n</UL>\n";

  if ($todie) { print "<HR>$footer \n</BODY></HTML>"; exit; }
}

# ------------------------------------------------------------- #
# Purpose: 	Displays the appropriate ORACLE error message	#
# Inputs:	The ORACLE error string				#
# ------------------------------------------------------------- #
sub Oracle_Error
{
  local($errstr) = shift(@_);

  print "<HTML><HEAD><TITLE>Error!</TITLE></HEAD>\n";
  print "<BODY><H1>$graphic Error! Error!</H1>\n";
  print "The following error(s) was encountered:\n";
  $_ = $errstr;
  if (/^Error/) {
    # Can't properly get Oracle error message
    if (/ORA-(.*)/) { 
      $err_no = join( "-", "ORA", $1); 
      if ($1 eq "06114") {
        $err_txt = "unknown two_task variable component (database)";
      } elsif ($1 eq "06105") {
        $err_txt = "unknown two_task variable component (host)";
      } elsif ($1 eq "06401") {
        $err_txt = "unknown two_task variable component (transport)";
      } else {
	$err_txt = $errstr;
      }
    } else {
      ($err_no, $err_txt) = split(/:/, $errstr);
    }
  } else {
    ($err_no, $err_txt) = split(/:/, $errstr);
  }
  
  print "<UL><LI><STRONG>$err_no</STRONG>: \n";
  print "$err_txt\n </UL>\n";
  print "<HR>$footer \n</BODY></HTML>";
  exit;

}

# ------------------------------------------------------------- #
# Purpose: 	Debugging                                	#
# Inputs:	The error string				#
# ------------------------------------------------------------- #
sub Debug
{
  local($errstr) = shift(@_);

  print "<HTML><HEAD><TITLE>Error!</TITLE></HEAD>\n";
  print "<BODY><H1>$graphic Error! Error!</H1>\n";
  print "$err_txt\n </UL>\n";
  print "<HR>$footer \n</BODY></HTML>";
  exit;

}

sub ora_open
{
   return 1;
}

sub ora_fetch
{
   return 1;
}

sub ora_login
{
   return 1;
}

sub ora_close
{
   return 1;
}

sub OneStep2Launch
{
   local($id) = shift(@_);
   if( $id eq undef )
   {
      $error = "NO_ID_PASSED" ;
      print "<H2>Script misconfiguration !</H2>";
      print "<P><H3>Try to use \"Back\" button on your browser, ";
      print "reload the page and start \"QFind\" again !</H3>";
      print "<P>Error code - $error";
      print "</BODY></HTML>";
      exit;
   }

   print "<FORM METHOD=POST ACTION=\"gotoqland.qfd?-L$id\">";
   print 'Now you are a citizen of a WebPhoneLand';
   print '<P>So you can launch ';
   print '<INPUT TYPE=submit VALUE=" WEBPhone ">' ;
   print '<P>Or if your address has been changed ';
   print 'or you created new home page.';
   print "<P>You can <A HREF=\"/htbin/changeAcc.pl?-L$id\">update</A> ";
   print 'your account information';

   print '<P><P>If you need additional information go';
   print 'back to our <A HREF="http://alonso/greeting.html">home page</A>';
}


#************************************************************
# MD5 cryptography
#   in  - string to crypt
#   out - 32 bytes crypted string
#         if lengthof the out-string is not equal 32 -> ERROR
#************************************************************
sub MD5
{
   local($object) = shift(@_);

   local($str) = "ERROR";
   local($id) = getppid;
   local($filename) = "/tmp/$object.$id";
   local($rc) = system( "./mddriver -s$object >$filename");
   if(!system( "./mddriver -s$object >$filename"))
   {
      open( MD5_IN, "$filename");
      while( <MD5_IN> )
      {
         $str = $_;
      }
      chop($str);
      $str =~ s/MD5\s\("$object"\)\s=\s//;
   }

   if( $str !~ /^ERRO/ && !unlink( "$filename" ) )
   {
      $str = "UNLINK_ERROR";
   }

   return $str;
}

1
